# std::__debug::multimap< _Key, _Tp, _Compare, _Allocator > Class Template Reference

Inheritance diagram for std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >:

List of all members.

## Detailed Description

### template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
class std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >

Definition at line 48 of file multimap.h.

## Public Types

- typedef _Allocator allocator_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::const_iterator,
  multimap > const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::iterator,
  multimap > iterator
- typedef _Compare key_compare
- typedef _Key key_type
- typedef _Tp mapped_type
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef _Base::size_type size_type
- typedef std::pair< const _Key,
  _Tp > value_type

## Public Member Functions

- const _Base & _M_base () const
- _Base & _M_base ()
- void _M_invalidate_all () const
- template<typename _Predicate> void _M_invalidate_if (_Predicate __pred)
- template<typename _Iterator> void _M_transfer_iter (const _Safe_iterator< _Iterator, _Sequence > &__x)
- const_iterator begin () const
- iterator begin ()
- void clear ()
- size_type count (const key_type &__x) const
- bool empty () const
- const_iterator end () const
- iterator end ()
- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__x) const
- std::pair< iterator, iterator > equal_range (const key_type &__x)
- void erase (iterator __first, iterator __last)
- void erase (iterator __position)
- void erase (iterator __first, iterator __last)
- size_type erase (const key_type &__x)
- void erase (iterator __position)
- const_iterator find (const key_type &__x) const
- iterator find (const key_type &__x)
- allocator_type get_allocator () const
- iterator insert (iterator __position, const value_type &__x)
- template<typename _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
- iterator insert (iterator __position, const value_type &__x)
- iterator insert (const value_type &__x)
- key_compare key_comp () const
- const_iterator lower_bound (const key_type &__x) const
- iterator lower_bound (const key_type &__x)
- size_type max_size () const
- multimap (const _Base &__x)
- multimap (const multimap< _Key, _Tp, _Compare, _Allocator > &__x)
- template<typename _InputIterator> multimap (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- multimap (const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- multimap< _Key, _Tp, _Compare,
  _Allocator > & operator= (const multimap< _Key, _Tp, _Compare, _Allocator > &__x)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- size_type size () const
- void swap (multimap &__x)
- void swap (multimap< _Key, _Tp, _Compare, _Allocator > &__x)
- const_iterator upper_bound (const key_type &__x) const
- iterator upper_bound (const key_type &__x)
- value_compare value_comp () const
- ~multimap ()

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Friends

- bool operator< (const multimap< _K1, _T1, _C1, _A1 > &, const multimap< _K1, _T1, _C1, _A1 > &)
- bool operator== (const multimap< _K1, _T1, _C1, _A1 > &, const multimap< _K1, _T1, _C1, _A1 > &)

## Constructor & Destructor Documentation

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | const _Compare & | __comp = `_Compare()`,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline, explicit]`

Default constructor creates no elements.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 80 of file multimap.h.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp = `_Compare()`,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline]`

Builds a multimap from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 85 of file multimap.h.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | `[protected, inherited]`

For use in _Safe_sequence.

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 220 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append(), std::__debug::vector< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign(), std::__debug::deque< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::c_str(), std::__debug::vector< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::clear(), std::__debug::deque< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::data(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase(), std::__debug::deque< _Tp, _Allocator >::erase(), __gnu_debug::getline(), std::__debug::vector< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert(), std::__debug::deque< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+=(), std::__debug::vector< _Tp, _Allocator >::operator=(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator=(), std::__debug::deque< _Tp, _Allocator >::operator=(), __gnu_debug::operator>>(), std::__debug::vector< _Tp, _Allocator >::push_back(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_front(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace(), std::__debug::vector< _Tp, _Allocator >::reserve(), std::__debug::vector< _Tp, _Allocator >::resize(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize(), std::__debug::deque< _Tp, _Allocator >::resize(), and __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap().

template<typename _Sequence>
template<typename _Predicate>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

Definition at line 126 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, and __gnu_debug::_Safe_sequence_base::_M_iterators.

Referenced by std::__debug::vector< _Tp, _Allocator >::erase(), std::__debug::vector< _Tp, _Allocator >::insert(), std::__debug::vector< _Tp, _Allocator >::resize(), and std::__debug::deque< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reasion, such as an exception, need to become valid again).

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

Referenced by std::__debug::vector< _Tp, _Allocator >::swap(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap(), std::__debug::set< _Key, _Compare, _Allocator >::swap(), std::__debug::multiset< _Key, _Compare, _Allocator >::swap(), std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::map< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::list< _Tp, _Allocator >::swap(), __gnu_cxx::__debug::hash_set< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multiset< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multimap< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_map< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), and std::__debug::deque< _Tp, _Allocator >::swap().

template<typename _Sequence>
template<typename _Iterator>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

Definition at line 159 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, __gnu_debug::_Safe_sequence_base::_M_iterators, __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

Referenced by std::__debug::list< _Tp, _Allocator >::splice().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 114 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::begin().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 110 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::begin().

Referenced by std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::clear(), and std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rend().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::clear | ( |  | ) | `[inline]`

Erases all elements in a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 207 of file multimap.h.

References std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin(), std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end(), and std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase().

size_type std::multimap< _Key , _Tp , _Compare , _Allocator >::count | ( | const key_type & | __x | ) | const`[inline, inherited]`

Finds the number of elements with given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Number of elements with specified key.

Definition at line 502 of file stl_multimap.h.

bool std::multimap< _Key , _Tp , _Compare , _Allocator >::empty | ( |  | ) | const`[inline, inherited]`

Returns true if the multimap is empty.

Definition at line 312 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 122 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::end().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 118 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::end().

Referenced by std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::clear(), and std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rbegin().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair<const_iterator,const_iterator> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 252 of file multimap.h.

References std::equal_range(), std::pair< _T1, _T2 >::first, std::make_pair(), and std::pair< _T1, _T2 >::second.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair<iterator,iterator> std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 242 of file multimap.h.

References std::equal_range(), std::pair< _T1, _T2 >::first, std::make_pair(), and std::pair< _T1, _T2 >::second.

Referenced by std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase().

void std::multimap< _Key , _Tp , _Compare , _Allocator >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  | `[inline, inherited]`

Erases a [first,last) range of elements from a multimap.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 420 of file stl_multimap.h.

void std::multimap< _Key , _Tp , _Compare , _Allocator >::erase | ( | iterator | __position | ) | `[inline, inherited]`

Erases an element from a multimap.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 390 of file stl_multimap.h.

Referenced by std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::erase | ( | const key_type & | __x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all elements located by the given key from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 175 of file multimap.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base(), std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::equal_range(), std::multimap< _Key, _Tp, _Compare, _Allocator >::erase(), std::pair< _T1, _T2 >::first, and std::pair< _T1, _T2 >::second.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) | const`[inline]`

Tries to locate an element in a multimap.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 220 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::find().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) | `[inline]`

Tries to locate an element in a multimap.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 216 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::find().

allocator_type std::multimap< _Key , _Tp , _Compare , _Allocator >::get_allocator | ( |  | ) | const`[inline, inherited]`

Get a copy of the memory allocation object.

Definition at line 233 of file stl_multimap.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::get_allocator().

iterator std::multimap< _Key , _Tp , _Compare , _Allocator >::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  | `[inline, inherited]`

Inserts a std::pair into the multimap.

Parameters:

  | position | An iterator that serves as a hint as to where the pair should be inserted.
  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 363 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

void std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 160 of file multimap.h.

References __glibcxx_check_valid_range, and std::multimap< _Key, _Tp, _Compare, _Allocator >::insert().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::insert | ( | const value_type & | __x | ) | `[inline]`

Inserts a std::pair into the multimap.

Parameters:

  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted.

Insertion requires logarithmic time.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 148 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::insert().

key_compare std::multimap< _Key , _Tp , _Compare , _Allocator >::key_comp | ( |  | ) | const`[inline, inherited]`

Returns the key comparison object out of which the multimap was constructed.

Definition at line 454 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful the iterator will point to the next greatest element or, if no such greater element exists, to end().

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 230 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 226 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::lower_bound().

size_type std::multimap< _Key , _Tp , _Compare , _Allocator >::max_size | ( |  | ) | const`[inline, inherited]`

Returns the maximum size of the multimap.

Definition at line 322 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 130 of file multimap.h.

References std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 126 of file multimap.h.

References std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::end().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 138 of file multimap.h.

References std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys.

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 134 of file multimap.h.

References std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::begin().

size_type std::multimap< _Key , _Tp , _Compare , _Allocator >::size | ( |  | ) | const`[inline, inherited]`

Returns the size of the multimap.

Definition at line 317 of file stl_multimap.h.

void std::multimap< _Key , _Tp , _Compare , _Allocator >::swap | ( | multimap< _Key, _Tp, _Compare, _Allocator > & | __x | ) | `[inline, inherited]`

Swaps data with another multimap.

Parameters:

  | x | A multimap of the same element and allocator types.

This exchanges the elements between two multimaps in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 435 of file stl_multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Alloc >::_M_t.

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first iterator greater than key, or end().

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 238 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound().

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Reimplemented from std::multimap< _Key, _Tp, _Compare, _Allocator >.

Definition at line 234 of file multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Allocator >::upper_bound().

value_compare std::multimap< _Key , _Tp , _Compare , _Allocator >::value_comp | ( |  | ) | const`[inline, inherited]`

Returns a value comparison object, built from the key comparison object out of which the multimap was constructed.

Definition at line 462 of file stl_multimap.h.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators`[inherited]`

The list of constant iterators that reference this container.

Definition at line 171 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators`[inherited]`

The list of mutable iterators that reference this container.

Definition at line 168 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version`[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 174 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

The documentation for this class was generated from the following file:

- multimap.h